CREATE OR REPLACE TRIGGER USR_BLOQ_WEB_SEM_PLAN
AFTER INSERT
ON ITEMSOLI FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_CONTADOR     FLOAT := 0;
BEGIN
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF V_DSSERVMETHOD = '/salvarDataProdNovo' THEN
      SELECT COUNT(1)
        INTO V_CONTADOR
        FROM (SELECT 1
                FROM PREVCONS
               WHERE CDFILIAL  = :NEW.CDFILSOLI
                 AND CDPRODUTO = :NEW.CDPRODUTO
                 AND TO_CHAR(DTPREVCONS, 'MM/YYYY') = TO_CHAR(:NEW.DTPROGENTR, 'MM/YYYY')
               UNION ALL
              SELECT 1
                FROM PREVCONSPDVDIA PC_PDV, PRODUTO P
               WHERE PC_PDV.CDPRODUTO = P.CDPRODUTO
                 AND PC_PDV.CDFILIAL  = :NEW.CDFILSOLI
                 AND P.CDPRODESTO     = :NEW.CDPRODUTO
                 AND TO_CHAR(PC_PDV.DTPRODCONPDV, 'MM/YYYY') = TO_CHAR(:NEW.DTPROGENTR, 'MM/YYYY')
                 AND NOT EXISTS (SELECT 1 FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PC_PDV.CDPRODUTO)
                 AND NOT EXISTS (SELECT 1
                                 FROM ROTFABLOCAL
                                 WHERE ROTFABLOCAL.CDPRODUTO = PC_PDV.CDPRODUTO
                                   AND ROTFABLOCAL.CDFILIAL = PC_PDV.CDFILIAL)
               UNION ALL
              SELECT 1
                FROM PREVCONSPDVDIA PC_PDV, PRODUTO P, ROTFABRICA ROT
               WHERE ROT.CDSUBPRODUTO = P.CDPRODUTO
                 AND ROT.CDPRODUTO    = PC_PDV.CDPRODUTO
                 AND PC_PDV.CDFILIAL  = :NEW.CDFILSOLI
                 AND P.CDPRODESTO     = :NEW.CDPRODUTO
                 AND TO_CHAR(PC_PDV.DTPRODCONPDV, 'MM/YYYY') = TO_CHAR(:NEW.DTPROGENTR, 'MM/YYYY')
                 AND NOT EXISTS (SELECT 1
                                 FROM ROTFABLOCAL
                                 WHERE ROTFABLOCAL.CDFILIAL = PC_PDV.CDFILIAL
                                   AND ROTFABLOCAL.CDPRODUTO = PC_PDV.CDPRODUTO)
               UNION ALL
              SELECT 1
                FROM PREVCONSPDVDIA PC_PDV, PRODUTO P, ROTFABLOCAL ROT
               WHERE ROT.CDSUBPRODLOC = P.CDPRODUTO
                 AND ROT.CDPRODUTO    = PC_PDV.CDPRODUTO
                 AND ROT.CDFILIAL     = PC_PDV.CDFILIAL
                 AND PC_PDV.CDFILIAL  = :NEW.CDFILSOLI
                 AND P.CDPRODESTO     = :NEW.CDPRODUTO
                 AND TO_CHAR(PC_PDV.DTPRODCONPDV, 'MM/YYYY') = TO_CHAR(:NEW.DTPROGENTR, 'MM/YYYY')
               UNION ALL
              SELECT 1
                FROM PREVCONSVMN
               WHERE CDFILIALCLIE = :NEW.CDFILSOLI
                 AND CDPRODUTO    = :NEW.CDPRODUTO
                 AND TO_CHAR(DTPREVENDVMN, 'MM/YYYY') = TO_CHAR(:NEW.DTPROGENTR, 'MM/YYYY')
               UNION ALL
              SELECT 1
                FROM PREVCONSPME
               WHERE CDFILIAL  = :NEW.CDFILSOLI
                 AND CDPRODUTO =:NEW.CDPRODUTO
                 AND TO_CHAR(DTPREVCONPME, 'MM/YYYY') = TO_CHAR(:NEW.DTPROGENTR, 'MM/YYYY')
               UNION ALL
              SELECT 1
                FROM PREVCOMPRA
               WHERE CDFILIAL  = :NEW.CDFILSOLI
                 AND CDPRODUTO = :NEW.CDPRODUTO
                 AND TO_CHAR(DTPREVCOMP, 'MM/YYYY') = TO_CHAR(:NEW.DTPROGENTR, 'MM/YYYY'));
      IF V_CONTADOR > 0 THEN
         RAISE_APPLICATION_ERROR(-20501, 'Operao bloqueada. Lanamento no  permitido para filial com planejamento.');
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_BLOQ_WEB_SEM_PLAN','6.35.023'); END;
/
